/* sort.h -*- C++ -*- sort interface
 * Rob Earhart
 * $Id: sort.h,v 1.2 1998/02/18 21:19:32 rob Exp $
 */
/***********************************************************
        Copyright 1997 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#ifndef ACAP_SORT_H
#define ACAP_SORT_H

// This defines a StrictWeakOrdering over entries, suitable for use in
// sorting and comparison.  Warning: it does NOT save its supplied
// sortlist_t.

#include "modifiers.h"

class EntryRef;

class Sort : public binary_function<EntryRef *, EntryRef *, bool> {
public:
  typedef Modifiers::sortlist_t sortlist_t;
  Sort(const sortlist_t &_sortlist) : sortlist(_sortlist) {}
  int compare(const EntryRef *a, const EntryRef *b) const;
  bool operator()(const EntryRef *a, const EntryRef *b) const {
    return compare(a, b) < 0;
  }
private:
  const sortlist_t &sortlist;
};

#endif // ACAP_SORT_H
