/* token.h -*- C++ -*- acap token declarations
 * Rob Earhart
 * $Id: token.h,v 1.2 1998/02/18 21:20:17 rob Exp $
 */
/***********************************************************
        Copyright 1997 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#ifndef ACAP_TOKEN_H
#define ACAP_TOKEN_H

#include "str.h"

// This really ought to be a namespace...
class Token {
public:
  typedef enum {
    // General tokens
    GARBAGE,
    CRLF,
    SPACE,
    TAG,
    QSTRING,
    LITERAL,
    NUMBER,
    STAR,
    LPAREN,
    RPAREN,

    // ACAP tokens (atoms + other strings)
    A_ACL,
    A_ADDTO,
    A_ALL,
    A_AND,
    A_ATTRIBUTE,
    A_AUTHENTICATE,
    A_CHANGE,
    A_COMPARE,
    A_COMPARESTRICT,
    A_CONTENTTYPE,
    A_COUNT,
    A_DATASETINHERIT,
    A_DEFAULT,
    A_DELETE,
    A_DELETEACL,
    A_DELETEDSINCE,
    A_DEPTH,
    A_ENTRY,
    A_ENUMERATE,
    A_EQUAL,
    A_FREECONTEXT,
    A_GETACL,
    A_HARDLIMIT,
    A_LANG,
    A_LIMIT,
    A_LISTRIGHTS,
    A_LOCK,
    A_LOGIN,
    A_LOGOUT,
    A_MAKECONTEXT,
    A_MODTIME,
    A_MYRIGHTS,
    A_NIL,
    A_NOCREATE,
    A_NOINHERIT,
    A_NOOP,
    A_NOT,
    A_NOTIFY,
    A_NOTIFYCONTEXT,
    A_OR,
    A_PREFIX,
    A_QUIT,
    A_RANGE,
    A_REMOVEFROM,
    A_RETURN,
    A_SEARCH,
    A_SETACL,
    A_SIZE,
    A_SORT,
    A_STORE,
    A_SUBDATASET,
    A_SUBSTRING,
    A_UNCHANGEDSINCE,
    A_UNLOCK,
    A_UPDATECONTEXT,
    A_VALUE
  } token;
  static token Lookup(const String &name);
};

#endif // ACAP_TOKEN_H
