/* updatecontext.h -*- C++ -*- updatecontext command interface
 * Rob Earhart
 * $Id: updatecontext.h,v 1.3 1997/12/19 22:25:46 rob Exp $
 */
/***********************************************************
        Copyright 1997 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

#ifndef ACAP_UPDATECONTEXT_H
#define ACAP_UPDATECONTEXT_H

#include <slist.h>
#include "command.h"
#include "notifycontext.h"

class UpdateContext : public Command {
public:
  typedef slist<P<NotifyContext> > contexts_t;

  // Note: this constructor turns its contexts argument into an
  // empty list, 'cause that's a lot more useful than copying it.  :-)
  // It also acquires a timestamp, for ordering, and should be called
  // while the dispatch queue's ordering lock is held.
  UpdateContext(const String &tag, Conn *conn, contexts_t &contexts);
private:
  contexts_t contexts;
  void Eval();
  Msg::Generator Name() const;
  Ptr<Timestamp> stamp;
};

#endif // ACAP_UPDATECONTEXT_H
